#ifndef MPI_STUFF_IS_INCLUDED
#define MPI_STUFF_IS_INCLUDED

#include <mpi.h>

//#define MPE_LOGGING

#ifdef MPE_LOGGING
#include <mpe.h>
#endif

typedef int MpiIdType;

typedef enum
  {
    TAG_PBUF,
    TAG_ZVAL
  } TagType;

#ifdef MPE_LOGGING
typedef enum
  {
    MPE_EVENT_RENDER_VOL_B,
    MPE_EVENT_RENDER_VOL_E,
    MPE_EVENT_READ_PIXELS_B,
    MPE_EVENT_READ_PIXELS_E,	
    MPE_EVENT_SEND_RECV_PIXELS_B,
    MPE_EVENT_SEND_RECV_PIXELS_E,
    MPE_EVENT_COLLECT_PIXELS_B,
    MPE_EVENT_COLLECT_PIXELS_E,
    MPE_EVENT_COMPOSE_B,
    MPE_EVENT_COMPOSE_E,
    MPE_EVENT_DRAW_PIXELS_B,
    MPE_EVENT_DRAW_PIXELS_E,	
    MPE_EVENT_BCAST_B,
    MPE_EVENT_BCAST_E
  } MpeEventType;
#endif

//____________________________________________________________________________
//
// MPI/Glut communication flags.
//____________________________________________________________________________

#define CMD_BUFFER_MAX_SIZE 10

typedef enum
  {
    CMD_DRAW,
    CMD_RESHAPE,
    CMD_MOUSE,
    CMD_MOTION,
    CMD_KEY,
    CMD_SPECIAL,
    CMD_QUIT,
    CMD_MASTERONLY,
    CMD_GUI    
  } CmdType;


#endif
