#ifndef SORT_LAST_H_INCLUDED
#define SORT_LAST_H_INCLUDED

#ifndef uint32_t
#define uint32_t unsigned int
#endif

#include "MpiStuff.h"

#ifndef NULL
#define NULL 0
#endif

#include <fstream>

class SortLast
{
 public:
  SortLast(unsigned int stages, unsigned int *config, 
	   int width, int height,
	   MPI_Comm &worldComm, MPI_Comm &slavesComm, 
	   int slavesSize, int masterIsSlave);
  ~SortLast();
  
  void Resize(int width, int height);

  void GetFrameBuffer(void);
  void Compose(MpiIdType *algRankToProc, int *algProcToRank);
  void Display(void* font = NULL, char* string = NULL);

  void CompositeBackWidgets(unsigned int start, unsigned int length);
  
 protected:
  unsigned int Stages;
  unsigned int *Config;
  
  int Width;
  int Height;
  
  MPI_Comm &WorldComm;
  MPI_Comm &SlavesComm;
  int MasterIsSlave;

  int WorldSize;
  int SlavesSize;
  int MyMpiRank;
  int MyAlgRank;
  
  int Size;
  int AdjustedSize;
  uint32_t *FrameBuffer;
  uint32_t *TmpFrameBuffer;
  uint32_t *WBehindFrameBuffer;

#ifdef DEBUG_TRACE_SORT_LAST
  std::ofstream *MyTrace;
#endif
  
 private:
  void Resize(void);
  void DoComposition(unsigned int startArea, unsigned int area,
		     unsigned int reverse);
  
  
 private:
  SortLast();
  SortLast(const SortLast&);
  SortLast& operator = (const SortLast&);
};

#endif
