/*
 * THC: Tools and Headers for C++
 * Copyright (C) 2002
 */

#include "Timer.h"

#include <unistd.h>

//____________________________________________________________________________

float Timer::MHz = 0.0;

#if defined (sgi) || defined(__sgi)
int Timer::scan_cpu_info(inventory_t *item, void */*foo*/)
{
  if ((item->inv_class == INV_PROCESSOR) && (item->inv_type == INV_CPUBOARD)) 
    {
      Timer::MHz = (int)item->inv_controller;
    }
  return 0;
}
#endif

bool Timer::InitMe(void)
{
#if defined (sgi) || defined(__sgi)
  scaninvent(Timer::scan_cpu_info, NULL);
#elif defined(linux)
  unsigned long long ostamp;
  unsigned long long stamp;
  float correction = 4000.0;
  
  /* Warm the cache */
  __asm__ __volatile__("rdtsc" : "=A" (ostamp) : /* no inputs */);
  usleep(1);
  __asm__ __volatile__("rdtsc" : "=A" (stamp) : /* no inputs */);
  stamp = stamp - ostamp;
  Timer::MHz = (float)stamp/(float)(1000000.0 + correction);
  
  __asm__ __volatile__("rdtsc" : "=A" (ostamp) : /* no inputs */);
  sleep(1);
  __asm__ __volatile__("rdtsc" : "=A" (stamp) : /* no inputs */);
  stamp = stamp - ostamp;
  Timer::MHz = (float)stamp/(float)(1000000.0 + correction);
#else
  Timer::MHz = -1;
#endif
  
  return true;
}

bool Timer::Init = Timer::InitMe();

//____________________________________________________________________________
