#ifndef _GLUTREDIRECT_H_ 
#define _GLUTREDIRECT_H_ 

#include <GL/glut.h>	   //glut includes gl and glu for you!
#include <fstream>
using namespace std;
#ifdef PARALLEL
#include "MpiStuff.h"

extern MpiIdType worldId;     // The process MPI id (in world AND slaves comm).
extern int masterIsSlave;     // whether or not we render vol on the display
extern MPI_Comm  worldComm;      // The global communicator.
extern MPI_Comm  slavesComm;     // The rendering nodes communicator.

#endif
void PglutPostRedisplay(void);

extern ofstream *mymsgs;
void start_logger(const char*prefix=".log_");
void close_logger();

//#define alog(PIPE) \
// {\
//*mymsgs PIPE;\
// }
#define alog(PIPE) {}

#ifdef PARALLEL
#define aprint(PIPE) \
  {\
  if (worldId==0) cerr PIPE;\
  }
#else
#define aprint(PIPE) \
  {\
  cerr PIPE;\
  }
#endif

#endif //_GLUTREDIRECT_H_ 
