#ifndef PBUFFERS_H
#define PBUFFERS_H

#ifdef WIN32
#include <windows.h>
#endif
#include "GL/gl.h"
#include <GL/glut.h>
#ifdef WIN32
#include "GL/wglext.h"
#endif
#include <GL/glext.h>

#define MAX_PFORMATS 256
#define MAX_ATTRIBS  32

class PBuffer
{
 private:
  HDC		 myDC;	    // Handle to a device context.
  HGLRC	 myGLctx;   // Handle to a GL context.
  unsigned int mode;	    // Flags indicating the type of pbuffer.
 public:
  int		 width;
  int		 height;
  PBuffer( int width, int height, unsigned int mode );
  ~PBuffer();
  void HandleModeSwitch();
  void MakeCurrent();
  void Initialize(bool share = false, bool rend2tex = false);
  HPBUFFERARB	 buffer;    // Handle to a pbuffer.

};

#endif


